import{s as $e,o as be,n as Te}from"../chunks/scheduler.defa9a21.js";import{S as we,i as ve,g as n,s as a,r as m,A as ge,h as r,f as l,c as d,j as Me,u as f,x as o,k as Vt,y as Le,a as i,v as c,d as p,t as h,w as u}from"../chunks/index.fe795e71.js";import{T as He}from"../chunks/Tip.179eb360.js";import{C as Xt}from"../chunks/CodeBlock.42404125.js";import{H as lt,E as _e}from"../chunks/EditOnGithub.0f575778.js";function Be(at){let s,T=`This API will load the model into memory on the <code>meta</code> device, so we are not actually downloading
and loading the full weights of the model into memory, nor do we need to. As a result it’s
perfectly fine to measure 8 billion parameter models (or more), without having to worry about
if your CPU can handle it!`;return{c(){s=n("p"),s.innerHTML=T},l(y){s=r(y,"P",{"data-svelte-h":!0}),o(s)!=="svelte-1byyf03"&&(s.innerHTML=T)},m(y,et){i(y,s,et)},p:Te,d(y){y&&l(s)}}}function xe(at){let s,T,y,et,w,dt,v,Nt="One very difficult aspect when exploring potential models to use on your machine is knowing just how big of a model will <em>fit</em> into memory with your current graphics card (such as loading the model onto CUDA).",nt,g,Jt=`To help alleviate this, Accelerate has a CLI interface through <code>accelerate estimate-memory</code>. This tutorial will
help walk you through using it, what to expect, and at the end link to the interactive demo hosted on the Hub which will
even let you post those results directly on the model repo!`,rt,L,It="Currently we support searching for models that can be used in <code>timm</code> and <code>transformers</code>.",ot,M,st,H,mt,_,Rt="Below are a few gradio demos related to what was described above. The first is the official Hugging Face memory estimation space, utilizing Accelerate directly:",ft,$,qt='<iframe src="https://hf-accelerate-model-memory-usage.hf.space?__theme=light" width="850" height="1600"></iframe>',ct,b,Dt='<iframe src="https://hf-accelerate-model-memory-usage.hf.space?__theme=dark" width="850" height="1600"></iframe>',pt,B,Qt='A community member has taken the idea and expanded it further, allowing you to filter models directly and see if you can run a particular LLM given GPU constraints and LoRA configurations. To play with it, see <a href="https://huggingface.co/spaces/Vokturz/can-it-run-llm" rel="nofollow">here</a> for more details.',ht,x,ut,C,Ot=`When using <code>accelerate estimate-memory</code>, you need to pass in the name of the model you want to use, potentially the framework
that model utilizing (if it can’t be found automatically), and the data types you want the model to be loaded in with.`,yt,k,Kt="For example, here is how we can calculate the memory footprint for <code>bert-base-cased</code>:",Mt,G,$t,P,te=`This will download the <code>config.json</code> for <code>bert-based-cased</code>, load the model on the <code>meta</code> device, and report back how much space
it will use:`,bt,W,ee="Memory Usage for loading <code>bert-base-cased</code>:",Tt,S,le="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>84.95 MB</td> <td>418.18 MB</td> <td>1.61 GB</td></tr> <tr><td>float16</td> <td>42.47 MB</td> <td>206.59 MB</td> <td>826.36 MB</td></tr> <tr><td>int8</td> <td>21.24 MB</td> <td>103.29 MB</td> <td>413.18 MB</td></tr> <tr><td>int4</td> <td>10.62 MB</td> <td>51.65 MB</td> <td>206.59 MB</td></tr></tbody>",wt,Z,ie="By default it will return all the supported dtypes (<code>int4</code> through <code>float32</code>), but if you are interested in specific ones these can be filtered.",vt,z,gt,A,ae=`If the source library cannot be determined automatically (like it could in the case of <code>bert-base-cased</code>), a library name can
be passed in.`,Lt,U,Ht,Y,de="Memory Usage for loading <code>HuggingFaceM4/idefics-80b-instruct</code>:",_t,j,ne="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>3.02 GB</td> <td>297.12 GB</td> <td>1.16 TB</td></tr> <tr><td>float16</td> <td>1.51 GB</td> <td>148.56 GB</td> <td>594.24 GB</td></tr> <tr><td>int8</td> <td>772.52 MB</td> <td>74.28 GB</td> <td>297.12 GB</td></tr> <tr><td>int4</td> <td>386.26 MB</td> <td>37.14 GB</td> <td>148.56 GB</td></tr></tbody>",Bt,F,xt,E,re="Memory Usage for loading <code>timm/resnet50.a1_in1k</code>:",Ct,V,oe="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>9.0 MB</td> <td>97.7 MB</td> <td>390.78 MB</td></tr> <tr><td>float16</td> <td>4.5 MB</td> <td>48.85 MB</td> <td>195.39 MB</td></tr> <tr><td>int8</td> <td>2.25 MB</td> <td>24.42 MB</td> <td>97.7 MB</td></tr> <tr><td>int4</td> <td>1.12 MB</td> <td>12.21 MB</td> <td>48.85 MB</td></tr></tbody>",kt,X,Gt,N,se="As mentioned earlier, while we return <code>int4</code> through <code>float32</code> by default, any dtype can be used from <code>float32</code>, <code>float16</code>, <code>int8</code>, and <code>int4</code>.",Pt,J,me="To do so, pass them in after specifying <code>--dtypes</code>:",Wt,I,St,R,fe="Memory Usage for loading <code>bert-base-cased</code>:",Zt,q,ce="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>84.95 MB</td> <td>413.18 MB</td> <td>1.61 GB</td></tr> <tr><td>float16</td> <td>42.47 MB</td> <td>206.59 MB</td> <td>826.36 MB</td></tr></tbody>",zt,D,At,Q,pe="This calculator will tell you how much memory is needed to purely load the model in, <em>not</em> to perform inference.",Ut,O,he="This calculation is accurate within a few % of the actual value, so it is a very good view of just how much memory it will take. For instance loading <code>bert-base-cased</code> actually takes <code>413.68 MB</code> when loaded on CUDA in full precision, and the calculator estimates <code>413.18 MB</code>.",Yt,K,ue=`When performing inference you can expect to add up to an additional 20% as found by <a href="https://blog.eleuther.ai/transformer-math/" rel="nofollow">EleutherAI</a>. We’ll be conducting research into finding a more accurate estimate to these values, and will update
this calculator once done.`,jt,tt,Ft,it,Et;return w=new lt({props:{title:"Model memory estimator",local:"model-memory-estimator",headingTag:"h1"}}),M=new He({props:{$$slots:{default:[Be]},$$scope:{ctx:at}}}),H=new lt({props:{title:"Gradio Demos",local:"gradio-demos",headingTag:"h2"}}),x=new lt({props:{title:"The Command",local:"the-command",headingTag:"h2"}}),G=new Xt({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMGJlcnQtYmFzZS1jYXNlZA==",highlighted:"accelerate estimate-memory bert-base-cased",wrap:!1}}),z=new lt({props:{title:"Specific libraries",local:"specific-libraries",headingTag:"h3"}}),U=new Xt({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMEh1Z2dpbmdGYWNlTTQlMkZpZGVmaWNzLTgwYi1pbnN0cnVjdCUyMC0tbGlicmFyeV9uYW1lJTIwdHJhbnNmb3JtZXJz",highlighted:"accelerate estimate-memory HuggingFaceM4/idefics-80b-instruct --library_name transformers",wrap:!1}}),F=new Xt({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMHRpbW0lMkZyZXNuZXQ1MC5hMV9pbjFrJTIwLS1saWJyYXJ5X25hbWUlMjB0aW1t",highlighted:"accelerate estimate-memory timm/resnet50.a1_in1k --library_name timm",wrap:!1}}),X=new lt({props:{title:"Specific dtypes",local:"specific-dtypes",headingTag:"h3"}}),I=new Xt({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMGJlcnQtYmFzZS1jYXNlZCUyMC0tZHR5cGVzJTIwZmxvYXQzMiUyMGZsb2F0MTY=",highlighted:"accelerate estimate-memory bert-base-cased --dtypes float32 float16",wrap:!1}}),D=new lt({props:{title:"Caveats with this calculator",local:"caveats-with-this-calculator",headingTag:"h2"}}),tt=new _e({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/usage_guides/model_size_estimator.md"}}),{c(){s=n("meta"),T=a(),y=n("p"),et=a(),m(w.$$.fragment),dt=a(),v=n("p"),v.innerHTML=Nt,nt=a(),g=n("p"),g.innerHTML=Jt,rt=a(),L=n("p"),L.innerHTML=It,ot=a(),m(M.$$.fragment),st=a(),m(H.$$.fragment),mt=a(),_=n("p"),_.textContent=Rt,ft=a(),$=n("div"),$.innerHTML=qt,ct=a(),b=n("div"),b.innerHTML=Dt,pt=a(),B=n("p"),B.innerHTML=Qt,ht=a(),m(x.$$.fragment),ut=a(),C=n("p"),C.innerHTML=Ot,yt=a(),k=n("p"),k.innerHTML=Kt,Mt=a(),m(G.$$.fragment),$t=a(),P=n("p"),P.innerHTML=te,bt=a(),W=n("p"),W.innerHTML=ee,Tt=a(),S=n("table"),S.innerHTML=le,wt=a(),Z=n("p"),Z.innerHTML=ie,vt=a(),m(z.$$.fragment),gt=a(),A=n("p"),A.innerHTML=ae,Lt=a(),m(U.$$.fragment),Ht=a(),Y=n("p"),Y.innerHTML=de,_t=a(),j=n("table"),j.innerHTML=ne,Bt=a(),m(F.$$.fragment),xt=a(),E=n("p"),E.innerHTML=re,Ct=a(),V=n("table"),V.innerHTML=oe,kt=a(),m(X.$$.fragment),Gt=a(),N=n("p"),N.innerHTML=se,Pt=a(),J=n("p"),J.innerHTML=me,Wt=a(),m(I.$$.fragment),St=a(),R=n("p"),R.innerHTML=fe,Zt=a(),q=n("table"),q.innerHTML=ce,zt=a(),m(D.$$.fragment),At=a(),Q=n("p"),Q.innerHTML=pe,Ut=a(),O=n("p"),O.innerHTML=he,Yt=a(),K=n("p"),K.innerHTML=ue,jt=a(),m(tt.$$.fragment),Ft=a(),it=n("p"),this.h()},l(t){const e=ge("svelte-u9bgzb",document.head);s=r(e,"META",{name:!0,content:!0}),e.forEach(l),T=d(t),y=r(t,"P",{}),Me(y).forEach(l),et=d(t),f(w.$$.fragment,t),dt=d(t),v=r(t,"P",{"data-svelte-h":!0}),o(v)!=="svelte-1qyhu4i"&&(v.innerHTML=Nt),nt=d(t),g=r(t,"P",{"data-svelte-h":!0}),o(g)!=="svelte-1kup5k5"&&(g.innerHTML=Jt),rt=d(t),L=r(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-w4272k"&&(L.innerHTML=It),ot=d(t),f(M.$$.fragment,t),st=d(t),f(H.$$.fragment,t),mt=d(t),_=r(t,"P",{"data-svelte-h":!0}),o(_)!=="svelte-1lyji5c"&&(_.textContent=Rt),ft=d(t),$=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o($)!=="svelte-1pqs7ii"&&($.innerHTML=qt),ct=d(t),b=r(t,"DIV",{class:!0,"data-svelte-h":!0}),o(b)!=="svelte-ocgkm1"&&(b.innerHTML=Dt),pt=d(t),B=r(t,"P",{"data-svelte-h":!0}),o(B)!=="svelte-7cbi9c"&&(B.innerHTML=Qt),ht=d(t),f(x.$$.fragment,t),ut=d(t),C=r(t,"P",{"data-svelte-h":!0}),o(C)!=="svelte-45l1al"&&(C.innerHTML=Ot),yt=d(t),k=r(t,"P",{"data-svelte-h":!0}),o(k)!=="svelte-h4f2xa"&&(k.innerHTML=Kt),Mt=d(t),f(G.$$.fragment,t),$t=d(t),P=r(t,"P",{"data-svelte-h":!0}),o(P)!=="svelte-ils653"&&(P.innerHTML=te),bt=d(t),W=r(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-1nfe19i"&&(W.innerHTML=ee),Tt=d(t),S=r(t,"TABLE",{"data-svelte-h":!0}),o(S)!=="svelte-1555s6h"&&(S.innerHTML=le),wt=d(t),Z=r(t,"P",{"data-svelte-h":!0}),o(Z)!=="svelte-1yqm0m1"&&(Z.innerHTML=ie),vt=d(t),f(z.$$.fragment,t),gt=d(t),A=r(t,"P",{"data-svelte-h":!0}),o(A)!=="svelte-njwxoj"&&(A.innerHTML=ae),Lt=d(t),f(U.$$.fragment,t),Ht=d(t),Y=r(t,"P",{"data-svelte-h":!0}),o(Y)!=="svelte-15w8ahh"&&(Y.innerHTML=de),_t=d(t),j=r(t,"TABLE",{"data-svelte-h":!0}),o(j)!=="svelte-18sp6z1"&&(j.innerHTML=ne),Bt=d(t),f(F.$$.fragment,t),xt=d(t),E=r(t,"P",{"data-svelte-h":!0}),o(E)!=="svelte-1mr9yqw"&&(E.innerHTML=re),Ct=d(t),V=r(t,"TABLE",{"data-svelte-h":!0}),o(V)!=="svelte-1kjhg7d"&&(V.innerHTML=oe),kt=d(t),f(X.$$.fragment,t),Gt=d(t),N=r(t,"P",{"data-svelte-h":!0}),o(N)!=="svelte-15o0uxk"&&(N.innerHTML=se),Pt=d(t),J=r(t,"P",{"data-svelte-h":!0}),o(J)!=="svelte-9rym4t"&&(J.innerHTML=me),Wt=d(t),f(I.$$.fragment,t),St=d(t),R=r(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-1nfe19i"&&(R.innerHTML=fe),Zt=d(t),q=r(t,"TABLE",{"data-svelte-h":!0}),o(q)!=="svelte-1hk5v9f"&&(q.innerHTML=ce),zt=d(t),f(D.$$.fragment,t),At=d(t),Q=r(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-gbqkuz"&&(Q.innerHTML=pe),Ut=d(t),O=r(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-wpwqvl"&&(O.innerHTML=he),Yt=d(t),K=r(t,"P",{"data-svelte-h":!0}),o(K)!=="svelte-1x4mgsf"&&(K.innerHTML=ue),jt=d(t),f(tt.$$.fragment,t),Ft=d(t),it=r(t,"P",{}),Me(it).forEach(l),this.h()},h(){Vt(s,"name","hf:doc:metadata"),Vt(s,"content",Ce),Vt($,"class","block dark:hidden"),Vt(b,"class","hidden dark:block")},m(t,e){Le(document.head,s),i(t,T,e),i(t,y,e),i(t,et,e),c(w,t,e),i(t,dt,e),i(t,v,e),i(t,nt,e),i(t,g,e),i(t,rt,e),i(t,L,e),i(t,ot,e),c(M,t,e),i(t,st,e),c(H,t,e),i(t,mt,e),i(t,_,e),i(t,ft,e),i(t,$,e),i(t,ct,e),i(t,b,e),i(t,pt,e),i(t,B,e),i(t,ht,e),c(x,t,e),i(t,ut,e),i(t,C,e),i(t,yt,e),i(t,k,e),i(t,Mt,e),c(G,t,e),i(t,$t,e),i(t,P,e),i(t,bt,e),i(t,W,e),i(t,Tt,e),i(t,S,e),i(t,wt,e),i(t,Z,e),i(t,vt,e),c(z,t,e),i(t,gt,e),i(t,A,e),i(t,Lt,e),c(U,t,e),i(t,Ht,e),i(t,Y,e),i(t,_t,e),i(t,j,e),i(t,Bt,e),c(F,t,e),i(t,xt,e),i(t,E,e),i(t,Ct,e),i(t,V,e),i(t,kt,e),c(X,t,e),i(t,Gt,e),i(t,N,e),i(t,Pt,e),i(t,J,e),i(t,Wt,e),c(I,t,e),i(t,St,e),i(t,R,e),i(t,Zt,e),i(t,q,e),i(t,zt,e),c(D,t,e),i(t,At,e),i(t,Q,e),i(t,Ut,e),i(t,O,e),i(t,Yt,e),i(t,K,e),i(t,jt,e),c(tt,t,e),i(t,Ft,e),i(t,it,e),Et=!0},p(t,[e]){const ye={};e&2&&(ye.$$scope={dirty:e,ctx:t}),M.$set(ye)},i(t){Et||(p(w.$$.fragment,t),p(M.$$.fragment,t),p(H.$$.fragment,t),p(x.$$.fragment,t),p(G.$$.fragment,t),p(z.$$.fragment,t),p(U.$$.fragment,t),p(F.$$.fragment,t),p(X.$$.fragment,t),p(I.$$.fragment,t),p(D.$$.fragment,t),p(tt.$$.fragment,t),Et=!0)},o(t){h(w.$$.fragment,t),h(M.$$.fragment,t),h(H.$$.fragment,t),h(x.$$.fragment,t),h(G.$$.fragment,t),h(z.$$.fragment,t),h(U.$$.fragment,t),h(F.$$.fragment,t),h(X.$$.fragment,t),h(I.$$.fragment,t),h(D.$$.fragment,t),h(tt.$$.fragment,t),Et=!1},d(t){t&&(l(T),l(y),l(et),l(dt),l(v),l(nt),l(g),l(rt),l(L),l(ot),l(st),l(mt),l(_),l(ft),l($),l(ct),l(b),l(pt),l(B),l(ht),l(ut),l(C),l(yt),l(k),l(Mt),l($t),l(P),l(bt),l(W),l(Tt),l(S),l(wt),l(Z),l(vt),l(gt),l(A),l(Lt),l(Ht),l(Y),l(_t),l(j),l(Bt),l(xt),l(E),l(Ct),l(V),l(kt),l(Gt),l(N),l(Pt),l(J),l(Wt),l(St),l(R),l(Zt),l(q),l(zt),l(At),l(Q),l(Ut),l(O),l(Yt),l(K),l(jt),l(Ft),l(it)),l(s),u(w,t),u(M,t),u(H,t),u(x,t),u(G,t),u(z,t),u(U,t),u(F,t),u(X,t),u(I,t),u(D,t),u(tt,t)}}}const Ce='{"title":"Model memory estimator","local":"model-memory-estimator","sections":[{"title":"Gradio Demos","local":"gradio-demos","sections":[],"depth":2},{"title":"The Command","local":"the-command","sections":[{"title":"Specific libraries","local":"specific-libraries","sections":[],"depth":3},{"title":"Specific dtypes","local":"specific-dtypes","sections":[],"depth":3}],"depth":2},{"title":"Caveats with this calculator","local":"caveats-with-this-calculator","sections":[],"depth":2}],"depth":1}';function ke(at){return be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ze extends we{constructor(s){super(),ve(this,s,ke,xe,$e,{})}}export{ze as component};
